## net-cpp 1.1.0+14.10.20140804

=== CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 2.8)

project(net-cpp)

find_package(Threads)

include(GNUInstallDirs)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fvisibility=hidden")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

set(NET_CPP_VERSION_MAJOR 1)
set(NET_CPP_VERSION_MINOR 1)
set(NET_CPP_VERSION_PATCH 0)

include(CTest)

include_directories(
  include/
)

add_subdirectory(doc)
add_subdirectory(data)
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tests)

=== src/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

find_package(Boost COMPONENTS system serialization REQUIRED)
find_package(CURL REQUIRED)

include_directories(${Boost_INCLUDE_DIRS} ${CURL_INCLUDE_DIRS})

add_library(
  net-cpp SHARED

  core/location.cpp

  core/net/error.cpp
  core/net/uri.cpp

  core/net/http/client.cpp
  core/net/http/error.cpp
  core/net/http/header.cpp
  core/net/http/request.cpp
  core/net/http/status.cpp

  core/net/http/impl/curl/client.cpp
  core/net/http/impl/curl/easy.cpp
  core/net/http/impl/curl/multi.cpp
  core/net/http/impl/curl/shared.cpp
)

target_link_libraries(
  net-cpp

  ${CMAKE_THREAD_LIBS_INIT}

  ${Boost_LIBRARIES}
  ${CURL_LIBRARIES}
)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")
set_target_properties(
  net-cpp

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${NET_CPP_VERSION_MAJOR}.${NET_CPP_VERSION_MINOR}.${NET_CPP_VERSION_PATCH}
  SOVERSION ${NET_CPP_VERSION_MAJOR}
)

install(
  TARGETS net-cpp
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

## net-cpp 1.1.0+15.04.20150305

=== tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

execute_process(
    COMMAND ${CMAKE_COMMAND} -E tar xf ${CMAKE_CURRENT_SOURCE_DIR}/httpbin.tar.bz2
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/httpbin.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/httpbin.h
    @ONLY
)

find_package(PkgConfig)
find_package(Threads)

pkg_check_modules(JSON_CPP jsoncpp)
pkg_check_modules(PROCESS_CPP process-cpp)

# Build with system gmock and embedded gtest
set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
set (GMOCK_BOTH_LIBRARIES gmock gmock_main)
add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}

    ${GMOCK_INCLUDE_DIR}
    ${GTEST_INCLUDE_DIR}
    ${JSON_CPP_INCLUDE_DIRS}
    ${PROCESS_CPP_INCLUDE_DIRS}
)

add_executable(
  header_test
  header_test.cpp
)

add_executable(
  http_client_test
  http_client_test.cpp
)

add_executable(
  http_client_load_test
  http_client_load_test.cpp
)

target_link_libraries(
    header_test

    net-cpp

    ${GMOCK_BOTH_LIBRARIES}
    ${JSON_CPP_LDFLAGS}
    ${PROCESS_CPP_LDFLAGS}
)

target_link_libraries(
    http_client_test

    net-cpp

    ${GMOCK_BOTH_LIBRARIES}
    ${JSON_CPP_LDFLAGS}
    ${PROCESS_CPP_LDFLAGS}
)

target_link_libraries(
    http_client_load_test

    net-cpp

    ${GMOCK_BOTH_LIBRARIES}
    ${JSON_CPP_LDFLAGS}
    ${PROCESS_CPP_LDFLAGS}
)

add_test(header_test ${CMAKE_CURRENT_BINARY_DIR}/header_test)
add_test(http_client_test ${CMAKE_CURRENT_BINARY_DIR}/http_client_test)
add_test(http_client_load_test ${CMAKE_CURRENT_BINARY_DIR}/http_client_load_test)

## net-cpp 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,8 +26,8 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 
-set(NET_CPP_VERSION_MAJOR 1)
-set(NET_CPP_VERSION_MINOR 1)
+set(NET_CPP_VERSION_MAJOR 2)
+set(NET_CPP_VERSION_MINOR 0)
 set(NET_CPP_VERSION_PATCH 0)
 
 include(CTest)
@@ -36,6 +36,8 @@
   include/
 )
 
+file(GLOB_RECURSE NET_CPP_INTERFACE_HEADERS include/*.h)
+
 add_subdirectory(doc)
 add_subdirectory(data)
 add_subdirectory(include)

=== Makefile ===
html:
	cat README.md|sed 's/(http:\/\/httpbin.org\//(\//'|ronn -5 -f --style 80c --pipe > ./httpbin/templates/httpbin.1.html

run: html
	foreman start

=== requirements.txt ===
Flask==0.9
Flask-Script==0.5.3
Jinja2==2.7
MarkupSafe==0.18
Werkzeug==0.8.3
argparse==1.2.1
blinker==1.2
decorator==3.3.2
distribute==0.6.34
gunicorn==0.17.4
raven==3.3.7
simplejson==2.4.0
wsgiref==0.1.2
gevent==1.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,8 @@
 
 add_library(
   net-cpp SHARED
+
+  ${NET_CPP_INTERFACE_HEADERS}
 
   core/location.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -57,6 +57,11 @@
 )
 
 add_executable(
+  http_streaming_client_test
+  http_streaming_client_test.cpp
+)
+
+add_executable(
   http_client_load_test
   http_client_load_test.cpp
 )
@@ -82,6 +87,16 @@
 )
 
 target_link_libraries(
+    http_streaming_client_test
+
+    net-cpp
+
+    ${GMOCK_BOTH_LIBRARIES}
+    ${JSON_CPP_LDFLAGS}
+    ${PROCESS_CPP_LDFLAGS}
+)
+
+target_link_libraries(
     http_client_load_test
 
     net-cpp
@@ -93,4 +108,5 @@
 
 add_test(header_test ${CMAKE_CURRENT_BINARY_DIR}/header_test)
 add_test(http_client_test ${CMAKE_CURRENT_BINARY_DIR}/http_client_test)
+add_test(http_streaming_client_test ${CMAKE_CURRENT_BINARY_DIR}/http_streaming_client_test)
 add_test(http_client_load_test ${CMAKE_CURRENT_BINARY_DIR}/http_client_load_test)

## net-cpp 2.1.0+16.10.20160913.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,11 @@
 #
 # Authored by: Thomas Voss <thomas.voss@canonical.com>
 
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.0)
 
-project(net-cpp)
+project(net-cpp VERSION 2.1.0)
+
+set(NET_CPP_SOVERSION 2 CACHE STRING "The version number from libnet-cpp's SONAME")
 
 find_package(Threads)
 
@@ -25,10 +27,7 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fvisibility=hidden")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
-
-set(NET_CPP_VERSION_MAJOR 2)
-set(NET_CPP_VERSION_MINOR 0)
-set(NET_CPP_VERSION_PATCH 0)
+add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)
 
 include(CTest)

## net-cpp 2.2.0+17.04.20161108.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 cmake_minimum_required(VERSION 3.0)
 
-project(net-cpp VERSION 2.1.0)
+project(net-cpp VERSION 2.2.0)
 
 set(NET_CPP_SOVERSION 2 CACHE STRING "The version number from libnet-cpp's SONAME")

## net-cpp 2.2.1%2Bdfsg1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -30,12 +30,7 @@
 pkg_check_modules(JSON_CPP jsoncpp)
 pkg_check_modules(PROCESS_CPP process-cpp)
 
-# Build with system gmock and embedded gtest
-set (GMOCK_INCLUDE_DIR "/usr/include/gmock/include" CACHE PATH "gmock source include directory")
-set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
-set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
-set (GMOCK_BOTH_LIBRARIES gmock gmock_main)
-add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")
+find_package(GMock)
 
 include_directories(
     ${CMAKE_CURRENT_BINARY_DIR}
@@ -71,7 +66,7 @@
 
     net-cpp
 
-    ${GMOCK_BOTH_LIBRARIES}
+    ${GMOCK_LIBRARIES}
     ${JSON_CPP_LDFLAGS}
     ${PROCESS_CPP_LDFLAGS}
 )
@@ -81,7 +76,7 @@
 
     net-cpp
 
-    ${GMOCK_BOTH_LIBRARIES}
+    ${GMOCK_LIBRARIES}
     ${JSON_CPP_LDFLAGS}
     ${PROCESS_CPP_LDFLAGS}
 )
@@ -91,7 +86,7 @@
 
     net-cpp
 
-    ${GMOCK_BOTH_LIBRARIES}
+    ${GMOCK_LIBRARIES}
     ${JSON_CPP_LDFLAGS}
     ${PROCESS_CPP_LDFLAGS}
 )
@@ -101,7 +96,7 @@
 
     net-cpp
 
-    ${GMOCK_BOTH_LIBRARIES}
+    ${GMOCK_LIBRARIES}
     ${JSON_CPP_LDFLAGS}
     ${PROCESS_CPP_LDFLAGS}
 )

## net-cpp 2.2.1+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 include(GNUInstallDirs)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fvisibility=hidden")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -pedantic -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -57,8 +57,8 @@
   PROPERTIES
   LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
   LINK_DEPENDS ${symbol_map}
-  VERSION ${NET_CPP_VERSION_MAJOR}.${NET_CPP_VERSION_MINOR}.${NET_CPP_VERSION_PATCH}
-  SOVERSION ${NET_CPP_VERSION_MAJOR}
+  VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
+  SOVERSION ${NET_CPP_SOVERSION}
 )
 
 install(

=== debian/changelog ===
net-cpp (2.2.1+dfsg1-6) unstable; urgency=medium

  * debian/rules:
    + Add dh_clean override, remove results.txt. This makes the build
      idempotent.
  * debian/control:
    + Switch from transitional google-mock to B-D googletest.
      Additionally add B-D libgtest-dev for GMock module in
      cmake-extras to be happy.
    + Update versioned B-D: cmake-extras (>= 1.5-5~). (Closes: #973214).
    + Bump to DH compat level version 13.
  * debian/libnet-cpp2.symbols:
    + Fix package name (add missing SOVERSION to the name).
  * debian/patches:
    + Forward patches that are non-specific for Debian to upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Oct 2020 08:46:52 +0100

net-cpp (2.2.1+dfsg1-5) unstable; urgency=medium

  * debian/changelog:
    + Typo fix in previous upload's stanza.
  * debian/patches/README:
    + Add file, explaining our patch naming scheme.
  * debian/patches:
    + Add 2001_no-tests-that-require-inet-access.patch. Disable tests that
      require internet access. (Closes: #964212).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 13 Jul 2020 12:41:20 +0200

net-cpp (2.2.1+dfsg1-4) unstable; urgency=medium

  * debian/libnet-cpp2.symbols:
    + Fix FTBFS on i386 m68k powerpc x32.
  * debian/patches:
    + Add 1007_wait-for-flask.patch. On slow build systems (e.g. armel, armhf,
      etc.), the tests run too early and the flask http server does not have
      enough time to come up. This patch injects an artificial delay of 3
      seconds between http server startup and client tests.

 -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Tue, 18 Feb 2020 13:24:20 +0100

net-cpp (2.2.1+dfsg1-3) unstable; urgency=medium

  * debian/control:
    + Add B-D pkg-kde-tools.
  * debian/rules:
    + Build --with pkgkde_symbolshelper.
  * debian/libnet-cpp2.symbols:
    + Update using pkg-kde-tools.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 17 Feb 2020 22:14:59 +0000

net-cpp (2.2.1+dfsg1-2) unstable; urgency=medium

  * debian/rules:
   + Only fix duplicate files in doc/html/ if that folder actually
     exists. Fixes binary-only DEB builds.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 03 Feb 2020 10:56:36 +0100

net-cpp (2.2.1+dfsg1-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #950434).
  * debian/patches:
    + Add 1001_no-bundled-httpbin.patch,
          1002_set-content-type-header-on-POSTs.patch,
          1003_port-to-new-json-cpp-API.patch.
      Fix multi-cause FTBFSes. Thanks to Luca Weiss for providing them.
    + Add 1004_INSTANTIATE_TEST_SUITE.patch. Fix Boost deprecation warnings.
    + Add 1005_typo-fix.patch. Typo fix in printed output.
    + Add 1006_doxygen-no-buildpath.patch. No FULL_PATH_NAMES in API docs.
  * debian/watch:
    + Add watch file.
  * debian/{control,compat}:
    + Switch to debhelper-compat notation. Bump to DH compat level version 12.
  * debian/control:
    + Update Maintainer: and Uploaders: fields.
    + Debian buildds don't support alternative B-Ds.
    + Build-depend on unversioned Boost library packages.
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Add B-D: cmake-extras.
    + Use system-wide python3-httpbin during unit tests. Add that to B-D.
    + Update Homepage: field (new upstream location).
    + Update Vcs-*: fields for Debian Git packaging on salsa.debian.org.
    + Fix SYNOPSIS of libnet-cpp-dev bin:pkg.
    + Lengthen the LONG_DESCRIPTION of libnet-cpp-doc a little bit to silence
      lintian.
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Add B-Ds: rdfind, symlinks.
  * debian/upstream/metadata:
    + Add file; comply with DEP-12.
  * debian/source/format:
    + Add format file; 3.0 (quilt).
  * debian/copyright:
    + Update Source: field with new upstream location.
    + Update copyright attributions for debian/*.
    + Use secure URL in Format: field.
  * debian/rules:
    + Run unit tests in non-parallel mode.
    + Introduce dh_missing override (--fail-missing).
    + Add get-orig-source target.
    + Enable all hardening build flags.
    + Fix doc:pkg file location, get rid of duplicate files in the API docs.
  * debian/libnet-cpp2.symbols:
    + Add Build-Depends-Package: metadata field.
    + Drop -0ubuntu1 from code versions.
  * debian/libnet-cpp1.symbols:
    + Drop file. Left-over from before the last SONAME bump.
  * debian/libnet-cpp-doc.doc-base:
    + Add file.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 01 Feb 2020 23:38:36 +0100

net-cpp (2.2.1+ubports) bionic; urgency=medium

  * Imported to UBports

 -- UBports auto importer <infra@ubports.com>  Mon, 09 Apr 2018 14:48:49 +0200

net-cpp (2.2.0+17.04.20161108.2-0ubuntu1) zesty; urgency=medium

  [ Gary Wang ]
  * Fix http header parsing in net response.
    (LP: #1631846)

 -- Gary.Wang <gary.wang@canonical.com>  Tue, 08 Nov 2016 09:21:39 +0000

net-cpp (2.1.0+16.10.20160913.2-0ubuntu1) yakkety; urgency=medium

  [ Thomas Voß ]
  [Gary Wang]
  * Enable pause/resume of requests.
  * Fix LP:#1570686 and LP:#1570687

  [ Gary Wang ]
  * Add data reading callback function in streaming http interface.
  * Fix LP:#1605179

 -- Gary.Wang <gary.wang@canonical.com>  Tue, 13 Sep 2016 08:55:30 +0000

net-cpp (2.0.0-0ubuntu2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 18:46:28 +0000

net-cpp (2.0.0-0ubuntu1) wily; urgency=medium

  * Bump version.

 -- Thomas Voß <thomas.voss@canonical.com>  Tue, 21 Jul 2015 11:44:30 +0200

net-cpp (2.0.0) wily; urgency=medium

  * Bump major revision to account for toolchain update. Fixes LP:#1452333.

 -- Thomas Voß <thomas.voss@canonical.com>  Mon, 20 Jul 2015 21:11:18 +0200

net-cpp (1.2.0+15.04.20150415.2-0ubuntu1) vivid; urgency=medium

  [ Thomas Voß ]
  * Introduce a streaming http interface.

 -- CI Train Bot <ci-train-bot@canonical.com>  Wed, 15 Apr 2015 12:34:49 +0000

net-cpp (1.1.0+15.04.20150305-0ubuntu1) vivid; urgency=medium

  [ thomas-voss ]


=== debian/control ===
Source: net-cpp
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 1.5-5~),
               debhelper-compat (= 13),
               doxygen,
               googletest,
               graphviz,
               libboost-dev (>= 1.58),
               libboost-serialization-dev (>= 1.58),
               libboost-system-dev (>= 1.58),
               libcurl4-openssl-dev,
               libgtest-dev,
               libjsoncpp-dev,
               libprocess-cpp-dev (>= 2.0.0),
               lsb-release,
               pkg-config,
               pkg-kde-tools,
               python3-httpbin,
               symlinks,
               rdfind,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Section: libs
Homepage: https://gitlab.com/ubports/core/lib-cpp/net-cpp
Vcs-Git: https://salsa.debian.org/ubports-team/net-cpp.git
Vcs-Browser: https://salsa.debian.org/ubports-team/net-cpp/

Package: libnet-cpp2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: C++11 library for networking purposes - runtime library
 Net-Cpp is a simple and straightforward networking library for C++11.
 .
 This package includes the net-cpp runtime libraries.

Package: libnet-cpp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libnet-cpp2 (= ${binary:Version}),
         ${misc:Depends},
Description: C++11 library for networking purposes - development headers
 Net-Cpp is a simple and straightforward networking library for C++11.
 .
 This package includes all the development headers and libraries for
 net-cpp.

Package: libnet-cpp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Suggests: libnet-cpp-dev,
Description: Documentation files for libnet-cpp-dev
 Net-Cpp is a simple and straightforward networking library for C++11.
 .
 This package includes the documentation files for the libnet-cpp
 development.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

# The home directory of user buildd does not exist on the builders
export XDG_DATA_HOME=/tmp

# Enable Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_test:
	dh_auto_test --no-parallel

override_dh_install:
	# Fix installation location of the doc:pkg files
	mv $(CURDIR)/debian/tmp/usr/share/doc/net-cpp \
	     $(CURDIR)/debian/tmp/usr/share/doc/libnet-cpp-doc
	dh_install
	# Get rid of duplicate files and replace them by symlinks
	if [ -d "$(CURDIR)/debian/libnet-cpp-doc/usr/share/doc/libnet-cpp-doc/html/" ]; then \
	    find "$(CURDIR)/debian/libnet-cpp-doc/usr/share/doc/libnet-cpp-doc/html/" -name *.md5 -delete; \
	    rdfind -makesymlinks true "$(CURDIR)/debian/libnet-cpp-doc/usr/share/doc/libnet-cpp-doc/html/"; \
	    symlinks -rc "$(CURDIR)/debian/libnet-cpp-doc/usr/share/doc/libnet-cpp-doc/html/"; \
	fi

override_dh_missing:
	dh_missing --fail-missing

override_dh_clean:
	dh_clean
	rm -f results.txt

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg1//,repacksuffix=+dfsg1 \
https://gitlab.com/ubports/core/lib-cpp/net-cpp/tags .*/net-cpp-(\d\S+)\.tar\.gz

## net-cpp 3.0.0%2Bdfsg1

=== debian/changelog ===
net-cpp (3.0.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 1001, 1002, 1003 and 1005. All applied upstream.
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 02 Dec 2021 08:06:02 +0100

## net-cpp 3.0.0+dfsg1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -13,10 +13,6 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # Authored by: Thomas Voss <thomas.voss@canonical.com>
-
-execute_process(
-    COMMAND ${CMAKE_COMMAND} -E tar xf ${CMAKE_CURRENT_SOURCE_DIR}/httpbin.tar.bz2
-    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
 
 configure_file(
     ${CMAKE_CURRENT_SOURCE_DIR}/httpbin.h.in

=== debian/changelog ===
net-cpp (3.0.0+dfsg1-3) unstable; urgency=medium

  * debian/:
    + Update upstream Git repo URL.
  * debian/control:
    + Bump Standards-Version: to 4.6.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 25 Jul 2022 17:42:57 +0200

net-cpp (3.0.0+dfsg1-2) unstable; urgency=medium

  * debian/patches:
    + Grab patches from upstream to fix newer liburl and fix tests
      (Closes: #1005475)
    + Refresh upstreamed patches
  * debian/control: Add myself as uploader

 -- Marius Gripsgard <marius@ubports.com>  Sat, 12 Mar 2022 00:52:09 +0100

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg1//,repacksuffix=+dfsg1 \
https://gitlab.com/ubports/development/core/lib-cpp/net-cpp/tags .*/net-cpp-(\d\S+)\.tar\.gz

## net-cpp 3.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 cmake_minimum_required(VERSION 3.0)
 
-project(net-cpp VERSION 2.2.0)
+project(net-cpp VERSION 3.1.0)
 
 set(NET_CPP_SOVERSION 2 CACHE STRING "The version number from libnet-cpp's SONAME")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -99,5 +99,7 @@
 
 add_test(header_test ${CMAKE_CURRENT_BINARY_DIR}/header_test)
 add_test(http_client_test ${CMAKE_CURRENT_BINARY_DIR}/http_client_test)
-add_test(http_streaming_client_test ${CMAKE_CURRENT_BINARY_DIR}/http_streaming_client_test)
+# FIXME: This test hangs when run under pbuilder and thus in CI, so we just
+# skip running for now. Re-enable once this is fixed.
+#add_test(http_streaming_client_test ${CMAKE_CURRENT_BINARY_DIR}/http_streaming_client_test)
 add_test(http_client_load_test ${CMAKE_CURRENT_BINARY_DIR}/http_client_load_test)

=== debian/changelog ===
net-cpp (3.1.0+dfsg-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)
  * Apply multi-arch hints. + libnet-cpp-doc: Add Multi-Arch: foreign.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.
  * Remove obsolete field Name from debian/upstream/metadata (already present in machine-readable debian/copyright).
  * Remove unnecessary get-orig-source-target.
  * Update standards version to 4.6.2, no changes needed.

  [ Mike Gabriel ]
  * Revert "Remove unnecessary get-orig-source-target."

  [ Marius Gripsgard ]
  * debian/patches: Add patch to bump c++ std version to 14 (closes: #1041122)

 -- Marius Gripsgard <mariogrip@debian.org>  Wed, 26 Jul 2023 04:12:04 +0200

net-cpp (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 0001, 0002, 1004 and 1006. Applied upstream.
    + Add 0004_CMakeLists.txt-Add-CMake-flag-ENABLE_WERROR-defaulti.patch.
      Disable -Werror for now via CMake option. (Closes: #1027648).
  * debian/copyright:
    + Update attributions for debian/.
    + Add autogenerated copyright.in file for later copyright reference
      tracking.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 02 Jan 2023 10:52:09 +0100

=== debian/control ===
--- 
+++ 
@@ -3,29 +3,30 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <marius@ubports.com>,
 Build-Depends: cmake,
                cmake-extras (>= 1.5-5~),
                debhelper-compat (= 13),
                doxygen,
                googletest,
                graphviz,
-               libboost-dev (>= 1.58),
-               libboost-serialization-dev (>= 1.58),
-               libboost-system-dev (>= 1.58),
+               libboost-dev,
+               libboost-serialization-dev,
+               libboost-system-dev,
                libcurl4-openssl-dev,
                libgtest-dev,
                libjsoncpp-dev,
-               libprocess-cpp-dev (>= 2.0.0),
+               libprocess-cpp-dev,
                lsb-release,
                pkg-config,
                pkg-kde-tools,
                python3-httpbin,
                symlinks,
                rdfind,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: libs
-Homepage: https://gitlab.com/ubports/core/lib-cpp/net-cpp
+Homepage: https://gitlab.com/ubports/development/core/lib-cpp/net-cpp
 Vcs-Git: https://salsa.debian.org/ubports-team/net-cpp.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/net-cpp/
 
@@ -58,6 +59,7 @@
 Architecture: all
 Depends: ${misc:Depends},
 Suggests: libnet-cpp-dev,
+Multi-Arch: foreign
 Description: Documentation files for libnet-cpp-dev
  Net-Cpp is a simple and straightforward networking library for C++11.
  .

## net-cpp 3.1.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,18 +16,24 @@
 
 cmake_minimum_required(VERSION 3.0)
 
-project(net-cpp VERSION 3.1.0)
+project(net-cpp VERSION 3.1.1)
 
 set(NET_CPP_SOVERSION 2 CACHE STRING "The version number from libnet-cpp's SONAME")
+
+option(ENABLE_WERROR "Treat all build warnings as errors" OFF)
 
 find_package(Threads)
 
 include(GNUInstallDirs)
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wall -pedantic -Wextra -fvisibility=hidden")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Werror -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -Wextra")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fvisibility=hidden")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)
+
+if(ENABLE_WERROR)
+    add_compile_options("-Werror")
+endif()
 
 include(CTest)
 
@@ -41,4 +47,6 @@
 add_subdirectory(data)
 add_subdirectory(include)
 add_subdirectory(src)
-add_subdirectory(tests)
+if(BUILD_TESTING)
+  add_subdirectory(tests)
+endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -23,8 +23,8 @@
 find_package(PkgConfig)
 find_package(Threads)
 
-pkg_check_modules(JSON_CPP jsoncpp)
-pkg_check_modules(PROCESS_CPP process-cpp)
+pkg_check_modules(JSON_CPP jsoncpp REQUIRED)
+pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
 
 find_package(GMock)

=== debian/changelog ===
net-cpp (3.1.1+dfsg-4) unstable; urgency=medium

  * debian/patches:
    + Simplify 1007_wait-for-flask.patch and use already present sleep_for()
      in tests/httpbin.h.in, increase it from 1sec to 5secs.
    + Trivially rebase 2001_no-tests-that-require-inet-access.patch.
    + Add 1008_set-MAX-CONTENT-LENGTH-for-flask-server-to-let-it-accept-big-
      chunks-of-data.patch. Set MAX_FORM_MEMORY_SIZE to a limit that can
      also handle the HttpClient.post_request_for_file_with_large_chunk_succeeds
      test. (Closes: #1088721).
  * debian/control:
    + In B-D: field, switch from pkg-config to pkgconf.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 12 Dec 2024 22:42:20 +0100

net-cpp (3.1.1+dfsg-3) unstable; urgency=medium

  * debian/libnet-cpp2.symbols:
    + Drop file. (Closes: #1015555).
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 16 Aug 2024 09:56:57 +0200

net-cpp (3.1.1+dfsg-2) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/copyright:
    + Drop Files-Excluded: line in top header. httpbin.tar.bz2 has been dropped
      upstream.
  * debian/control:
    + Versionize B-D on libprocess-cpp-dev. Require process-cpp (>= 3.0.2)
      (which comes with a fixed SOVERSION_MAJOR).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 16 Aug 2024 09:50:17 +0200

net-cpp (3.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0003-tests-JSON_CPP-and-PROCESS_CPP-are-required-deps.patch
      and 0004_CMakeLists.txt-Add-CMake-flag-ENABLE_WERROR-defaulti.patch.
      Applied upstream.
  * debian/copyright:
    + Update copyright attribution for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 01 Feb 2024 17:57:26 +0100

=== debian/control ===
--- 
+++ 
@@ -16,14 +16,14 @@
                libcurl4-openssl-dev,
                libgtest-dev,
                libjsoncpp-dev,
-               libprocess-cpp-dev,
+               libprocess-cpp-dev (>= 3.0.2),
                lsb-release,
-               pkg-config,
+               pkgconf,
                pkg-kde-tools,
                python3-httpbin,
                symlinks,
                rdfind,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://gitlab.com/ubports/development/core/lib-cpp/net-cpp

=== debian/watch ===
version=4
opts="searchmode=plain, repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/core/lib-cpp/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@

## net-cpp 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,9 @@
 #
 # Authored by: Thomas Voss <thomas.voss@canonical.com>
 
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.10)
 
-project(net-cpp VERSION 3.1.1)
+project(net-cpp VERSION 3.2.0)
 
 set(NET_CPP_SOVERSION 2 CACHE STRING "The version number from libnet-cpp's SONAME")
 
@@ -27,7 +27,7 @@
 include(GNUInstallDirs)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fvisibility=hidden")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -Wall -fno-strict-aliasing -fvisibility=hidden -fvisibility-inlines-hidden -Wextra")
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
 add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

=== data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

configure_file(
  net-cpp.pc.in net-cpp.pc @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/net-cpp.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== doc/CMakeLists.txt ===
option(
  NET_CPP_ENABLE_DOC_GENERATION
  "Generate package documentation with doxygen"
  ON
)

if (NET_CPP_ENABLE_DOC_GENERATION)

find_package(Doxygen)

if (DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION ${CMAKE_INSTALL_DOCDIR})

endif (DOXYGEN_FOUND)
endif (NET_CPP_ENABLE_DOC_GENERATION)

=== include/CMakeLists.txt ===
install(
  DIRECTORY core
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # Authored by: Thomas Voss <thomas.voss@canonical.com>
 
 find_package(Boost COMPONENTS system serialization REQUIRED)
-find_package(CURL REQUIRED)
+find_package(CURL 7.32 REQUIRED)
 
 include_directories(${Boost_INCLUDE_DIRS} ${CURL_INCLUDE_DIRS})

=== debian/changelog ===
net-cpp (3.2.0-1) unstable; urgency=medium

  * New upstream release.
    - Support building with CMake 4. (Closes: #1113318).
  * debian/watch:
    + Drop +dfsg suffix handling. Suffix not used anymore starting with v3.2.0.
  * debian/rules:
    + Drop --repack option for uscan call in get-orig-source target.
  * debian/patches:
    + Drop 0001-Bump-std-version-to-14-needed-for-googletest-1.13.0.patch, 1007_
      wait-for-flask.patch, 1008_set-MAX-CONTENT-LENGTH-for-flask-server-to-let-
      it-accept-big-chunks-of-data.patch. All applied upstream.
  * debian/copyright:
    + Update copyright attributions for debian/.
  * debian/{control,rules}:
    + Stop using pkgkde_symbolshelper DH extension, drop pkg-kde-tools from
      B-D: field.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 02 Sep 2025 10:32:30 +0200

=== debian/control ===
--- 
+++ 
@@ -19,11 +19,10 @@
                libprocess-cpp-dev (>= 3.0.2),
                lsb-release,
                pkgconf,
-               pkg-kde-tools,
                python3-httpbin,
                symlinks,
                rdfind,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://gitlab.com/ubports/development/core/lib-cpp/net-cpp

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with pkgkde_symbolshelper
+	dh $@
 
 override_dh_auto_test:
 	dh_auto_test --no-parallel
@@ -37,4 +37,4 @@
 	rm -f results.txt
 
 get-orig-source:
-	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..
+	uscan --noconf --force-download --rename --download-current-version --destdir=..
